"use strict";

var expectedActionTypes = _interopRequireWildcard(require("../actionTypes"));

var _propTypes = _interopRequireWildcard(require("../propTypes"));

var _immutable = require("../immutable");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('immutable', function () {
  it('should export actionTypes', function () {
    expect(_immutable.actionTypes).toEqual(expectedActionTypes);
  });
  it('should export arrayInsert', function () {
    expect(typeof _immutable.arrayInsert).toBe('function');
  });
  it('should export arrayMove', function () {
    expect(typeof _immutable.arrayMove).toBe('function');
  });
  it('should export arrayPop', function () {
    expect(typeof _immutable.arrayPop).toBe('function');
  });
  it('should export arrayPush', function () {
    expect(typeof _immutable.arrayPush).toBe('function');
  });
  it('should export arrayRemove', function () {
    expect(typeof _immutable.arrayRemove).toBe('function');
  });
  it('should export arrayRemoveAll', function () {
    expect(typeof _immutable.arrayRemoveAll).toBe('function');
  });
  it('should export arrayShift', function () {
    expect(typeof _immutable.arrayShift).toBe('function');
  });
  it('should export arraySplice', function () {
    expect(typeof _immutable.arraySplice).toBe('function');
  });
  it('should export arraySwap', function () {
    expect(typeof _immutable.arraySwap).toBe('function');
  });
  it('should export arrayUnshift', function () {
    expect(typeof _immutable.arrayUnshift).toBe('function');
  });
  it('should export autofill', function () {
    expect(typeof _immutable.autofill).toBe('function');
  });
  it('should export blur', function () {
    expect(typeof _immutable.blur).toBe('function');
  });
  it('should export change', function () {
    expect(typeof _immutable.change).toBe('function');
  });
  it('should export clearSubmitErrors', function () {
    expect(typeof _immutable.clearSubmitErrors).toBe('function');
  });
  it('should export defaultShouldAsyncValidate', function () {
    expect(typeof _immutable.defaultShouldAsyncValidate).toBe('function');
  });
  it('should export defaultShouldValidate', function () {
    expect(typeof _immutable.defaultShouldValidate).toBe('function');
  });
  it('should export defaultShouldError', function () {
    expect(typeof _immutable.defaultShouldError).toBe('function');
  });
  it('should export defaultShouldWarn', function () {
    expect(typeof _immutable.defaultShouldWarn).toBe('function');
  });
  it('should export destroy', function () {
    expect(typeof _immutable.destroy).toBe('function');
  });
  it('should export Field', function () {
    expect(typeof _immutable.Field).toBe('object');
  });
  it('should export Fields', function () {
    expect(typeof _immutable.Fields).toBe('object');
  });
  it('should export FieldArray', function () {
    expect(typeof _immutable.FieldArray).toBe('object');
  });
  it('should export Form', function () {
    expect(typeof _immutable.Form).toBe('object');
  });
  it('should export FormSection', function () {
    expect(typeof _immutable.FormSection).toBe('object');
  });
  it('should export focus', function () {
    expect(typeof _immutable.focus).toBe('function');
  });
  it('should export formValueSelector', function () {
    expect(typeof _immutable.formValueSelector).toBe('function');
  });
  it('should export getFormValues', function () {
    expect(typeof _immutable.getFormValues).toBe('function');
  });
  it('should export getFormInitialValues', function () {
    expect(typeof _immutable.getFormInitialValues).toBe('function');
  });
  it('should export getFormSyncErrors', function () {
    expect(typeof _immutable.getFormSyncErrors).toBe('function');
  });
  it('should export getFormMeta', function () {
    expect(typeof _immutable.getFormMeta).toBe('function');
  });
  it('should export getFormAsyncErrors', function () {
    expect(typeof _immutable.getFormAsyncErrors).toBe('function');
  });
  it('should export getFormSyncWarnings', function () {
    expect(typeof _immutable.getFormSyncWarnings).toBe('function');
  });
  it('should export getFormSubmitErrors', function () {
    expect(typeof _immutable.getFormSubmitErrors).toBe('function');
  });
  it('should export initialize', function () {
    expect(typeof _immutable.initialize).toBe('function');
  });
  it('should export isDirty', function () {
    expect(typeof _immutable.isDirty).toBe('function');
  });
  it('should export isInvalid', function () {
    expect(typeof _immutable.isInvalid).toBe('function');
  });
  it('should export isPristine', function () {
    expect(typeof _immutable.isPristine).toBe('function');
  });
  it('should export isValid', function () {
    expect(typeof _immutable.isValid).toBe('function');
  });
  it('should export isSubmitting', function () {
    expect(typeof _immutable.isSubmitting).toBe('function');
  });
  it('should export hasSubmitSucceeded', function () {
    expect(typeof _immutable.hasSubmitSucceeded).toBe('function');
  });
  it('should export hasSubmitFailed', function () {
    expect(typeof _immutable.hasSubmitFailed).toBe('function');
  });
  it('should export fieldPropTypes', function () {
    expect(_immutable.fieldPropTypes).toEqual(_propTypes.fieldPropTypes);
  });
  it('should export fieldArrayPropTypes', function () {
    expect(_immutable.fieldArrayPropTypes).toEqual(_propTypes.fieldArrayPropTypes);
  });
  it('should export propTypes', function () {
    expect(_immutable.propTypes).toEqual(_propTypes.default);
  });
  it('should export formPropTypes', function () {
    expect(_immutable.formPropTypes).toEqual(_propTypes.default);
  });
  it('should export reducer', function () {
    expect(typeof _immutable.reducer).toBe('function');
  });
  it('should export reduxForm', function () {
    expect(typeof _immutable.reduxForm).toBe('function');
  });
  it('should export registerField', function () {
    expect(typeof _immutable.registerField).toBe('function');
  });
  it('should export reset', function () {
    expect(typeof _immutable.reset).toBe('function');
  });
  it('should export resetSection', function () {
    expect(typeof _immutable.resetSection).toBe('function');
  });
  it('should export startAsyncValidation', function () {
    expect(typeof _immutable.startAsyncValidation).toBe('function');
  });
  it('should export startSubmit', function () {
    expect(typeof _immutable.startSubmit).toBe('function');
  });
  it('should export setSubmitFailed', function () {
    expect(typeof _immutable.setSubmitFailed).toBe('function');
  });
  it('should export setSubmitSucceeded', function () {
    expect(typeof _immutable.setSubmitSucceeded).toBe('function');
  });
  it('should export stopAsyncValidation', function () {
    expect(typeof _immutable.stopAsyncValidation).toBe('function');
  });
  it('should export stopSubmit', function () {
    expect(typeof _immutable.stopSubmit).toBe('function');
  });
  it('should export submit', function () {
    expect(typeof _immutable.submit).toBe('function');
  });
  it('should export SubmissionError', function () {
    expect(typeof _immutable.SubmissionError).toBe('function');
  });
  it('should export touch', function () {
    expect(typeof _immutable.touch).toBe('function');
  });
  it('should export unregisterField', function () {
    expect(typeof _immutable.unregisterField).toBe('function');
  });
  it('should export untouch', function () {
    expect(typeof _immutable.untouch).toBe('function');
  });
  it('should export values', function () {
    expect(typeof _immutable.values).toBe('function');
  });
});