"use strict";

var expectedActionTypes = _interopRequireWildcard(require("../actionTypes"));

var _propTypes = _interopRequireWildcard(require("../propTypes"));

var _index = require("../index");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('index', function () {
  it('should export actionTypes', function () {
    expect(_index.actionTypes).toEqual(expectedActionTypes);
  });
  it('should export arrayInsert', function () {
    expect(typeof _index.arrayInsert).toBe('function');
  });
  it('should export arrayMove', function () {
    expect(typeof _index.arrayMove).toBe('function');
  });
  it('should export arrayPop', function () {
    expect(typeof _index.arrayPop).toBe('function');
  });
  it('should export arrayPush', function () {
    expect(typeof _index.arrayPush).toBe('function');
  });
  it('should export arrayRemove', function () {
    expect(typeof _index.arrayRemove).toBe('function');
  });
  it('should export arrayRemoveAll', function () {
    expect(typeof _index.arrayRemoveAll).toBe('function');
  });
  it('should export arrayShift', function () {
    expect(typeof _index.arrayShift).toBe('function');
  });
  it('should export arraySplice', function () {
    expect(typeof _index.arraySplice).toBe('function');
  });
  it('should export arraySwap', function () {
    expect(typeof _index.arraySwap).toBe('function');
  });
  it('should export arrayUnshift', function () {
    expect(typeof _index.arrayUnshift).toBe('function');
  });
  it('should export autofill', function () {
    expect(typeof _index.autofill).toBe('function');
  });
  it('should export blur', function () {
    expect(typeof _index.blur).toBe('function');
  });
  it('should export change', function () {
    expect(typeof _index.change).toBe('function');
  });
  it('should export clearSubmitErrors', function () {
    expect(typeof _index.clearSubmitErrors).toBe('function');
  });
  it('should export defaultShouldAsyncValidate', function () {
    expect(typeof _index.defaultShouldAsyncValidate).toBe('function');
  });
  it('should export defaultShouldValidate', function () {
    expect(typeof _index.defaultShouldValidate).toBe('function');
  });
  it('should export defaultShouldError', function () {
    expect(typeof _index.defaultShouldError).toBe('function');
  });
  it('should export defaultShouldWarn', function () {
    expect(typeof _index.defaultShouldWarn).toBe('function');
  });
  it('should export destroy', function () {
    expect(typeof _index.destroy).toBe('function');
  });
  it('should export Field', function () {
    expect(typeof _index.Field).toBe('object');
  });
  it('should export Fields', function () {
    expect(typeof _index.Fields).toBe('object');
  });
  it('should export FieldArray', function () {
    expect(typeof _index.FieldArray).toBe('object');
  });
  it('should export Form', function () {
    expect(typeof _index.Form).toBe('object');
  });
  it('should export FormSection', function () {
    expect(typeof _index.FormSection).toBe('object');
  });
  it('should export focus', function () {
    expect(typeof _index.focus).toBe('function');
  });
  it('should export formValueSelector', function () {
    expect(typeof _index.formValueSelector).toBe('function');
  });
  it('should export getFormNames', function () {
    expect(typeof _index.getFormNames).toBe('function');
  });
  it('should export getFormValues', function () {
    expect(typeof _index.getFormValues).toBe('function');
  });
  it('should export getFormInitialValues', function () {
    expect(typeof _index.getFormInitialValues).toBe('function');
  });
  it('should export getFormSyncErrors', function () {
    expect(typeof _index.getFormSyncErrors).toBe('function');
  });
  it('should export getFormMeta', function () {
    expect(typeof _index.getFormMeta).toBe('function');
  });
  it('should export getFormAsyncErrors', function () {
    expect(typeof _index.getFormAsyncErrors).toBe('function');
  });
  it('should export getFormSyncWarnings', function () {
    expect(typeof _index.getFormSyncWarnings).toBe('function');
  });
  it('should export getFormSubmitErrors', function () {
    expect(typeof _index.getFormSubmitErrors).toBe('function');
  });
  it('should export initialize', function () {
    expect(typeof _index.initialize).toBe('function');
  });
  it('should export isDirty', function () {
    expect(typeof _index.isDirty).toBe('function');
  });
  it('should export isInvalid', function () {
    expect(typeof _index.isInvalid).toBe('function');
  });
  it('should export isPristine', function () {
    expect(typeof _index.isPristine).toBe('function');
  });
  it('should export isValid', function () {
    expect(typeof _index.isValid).toBe('function');
  });
  it('should export isSubmitting', function () {
    expect(typeof _index.isSubmitting).toBe('function');
  });
  it('should export hasSubmitSucceeded', function () {
    expect(typeof _index.hasSubmitSucceeded).toBe('function');
  });
  it('should export hasSubmitFailed', function () {
    expect(typeof _index.hasSubmitFailed).toBe('function');
  });
  it('should export fieldPropTypes', function () {
    expect(_index.fieldPropTypes).toEqual(_propTypes.fieldPropTypes);
  });
  it('should export fieldArrayPropTypes', function () {
    expect(_index.fieldArrayPropTypes).toEqual(_propTypes.fieldArrayPropTypes);
  });
  it('should export propTypes', function () {
    expect(_index.propTypes).toEqual(_propTypes.default);
  });
  it('should export formPropTypes', function () {
    expect(_index.formPropTypes).toEqual(_propTypes.default);
  });
  it('should export reducer', function () {
    expect(typeof _index.reducer).toBe('function');
  });
  it('should export reduxForm', function () {
    expect(typeof _index.reduxForm).toBe('function');
  });
  it('should export registerField', function () {
    expect(typeof _index.registerField).toBe('function');
  });
  it('should export reset', function () {
    expect(typeof _index.reset).toBe('function');
  });
  it('should export resetSection', function () {
    expect(typeof _index.resetSection).toBe('function');
  });
  it('should export startAsyncValidation', function () {
    expect(typeof _index.startAsyncValidation).toBe('function');
  });
  it('should export startSubmit', function () {
    expect(typeof _index.startSubmit).toBe('function');
  });
  it('should export setSubmitFailed', function () {
    expect(typeof _index.setSubmitFailed).toBe('function');
  });
  it('should export setSubmitSucceeded', function () {
    expect(typeof _index.setSubmitSucceeded).toBe('function');
  });
  it('should export stopAsyncValidation', function () {
    expect(typeof _index.stopAsyncValidation).toBe('function');
  });
  it('should export stopSubmit', function () {
    expect(typeof _index.stopSubmit).toBe('function');
  });
  it('should export submit', function () {
    expect(typeof _index.submit).toBe('function');
  });
  it('should export SubmissionError', function () {
    expect(typeof _index.SubmissionError).toBe('function');
  });
  it('should export touch', function () {
    expect(typeof _index.touch).toBe('function');
  });
  it('should export unregisterField', function () {
    expect(typeof _index.unregisterField).toBe('function');
  });
  it('should export untouch', function () {
    expect(typeof _index.untouch).toBe('function');
  });
  it('should export values', function () {
    expect(typeof _index.values).toBe('function');
  });
});