"use strict";

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _isEvent = _interopRequireDefault(require("../isEvent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('isEvent', function () {
  it('should return false if event is undefined', function () {
    expect((0, _isEvent.default)()).toBe(false);
  });
  it('should return false if event is null', function () {
    expect((0, _isEvent.default)(null)).toBe(false);
  });
  it('should return false if event is not an object', function () {
    expect((0, _isEvent.default)(42)).toBe(false);
    expect((0, _isEvent.default)(true)).toBe(false);
    expect((0, _isEvent.default)(false)).toBe(false);
    expect((0, _isEvent.default)('not an event')).toBe(false);
  });
  it('should return false if event has no stopPropagation', function () {
    expect((0, _isEvent.default)({
      preventDefault: _noop2.default
    })).toBe(false);
  });
  it('should return false if event has no preventDefault', function () {
    expect((0, _isEvent.default)({
      stopPropagation: _noop2.default
    })).toBe(false);
  });
  it('should return true if event has stopPropagation, and preventDefault', function () {
    expect((0, _isEvent.default)({
      stopPropagation: _noop2.default,
      preventDefault: _noop2.default
    })).toBe(true);
  });
});