"use strict";

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _silenceEvent = _interopRequireDefault(require("../silenceEvent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('silenceEvent', function () {
  it('should return false if not an event', function () {
    expect((0, _silenceEvent.default)(undefined)).toBe(false);
    expect((0, _silenceEvent.default)(null)).toBe(false);
    expect((0, _silenceEvent.default)(true)).toBe(false);
    expect((0, _silenceEvent.default)(42)).toBe(false);
    expect((0, _silenceEvent.default)({})).toBe(false);
    expect((0, _silenceEvent.default)([])).toBe(false);
    expect((0, _silenceEvent.default)(_noop2.default)).toBe(false);
  });
  it('should return true if an event', function () {
    expect((0, _silenceEvent.default)({
      preventDefault: _noop2.default,
      stopPropagation: _noop2.default
    })).toBe(true);
  });
  it('should call preventDefault and stopPropagation', function () {
    var preventDefault = jest.fn();
    var stopPropagation = jest.fn();
    (0, _silenceEvent.default)({
      preventDefault: preventDefault,
      stopPropagation: stopPropagation
    });
    expect(preventDefault).toHaveBeenCalled();
    expect(stopPropagation).not.toHaveBeenCalled();
  });
});