"use strict";

var _getFormInitialValues = _interopRequireDefault(require("../getFormInitialValues"));

var _plain = _interopRequireDefault(require("../../structure/plain"));

var _expectations = _interopRequireDefault(require("../../structure/plain/__tests__/expectations"));

var _immutable = _interopRequireDefault(require("../../structure/immutable"));

var _expectations2 = _interopRequireDefault(require("../../structure/immutable/__tests__/expectations"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var describeGetFormInitialValues = function describeGetFormInitialValues(name, structure, setup) {
  var getFormInitialValues = (0, _getFormInitialValues.default)(structure);
  var fromJS = structure.fromJS,
      getIn = structure.getIn;
  describe(name, function () {
    beforeAll(function () {
      setup();
    });
    it('should return a function', function () {
      expect(typeof getFormInitialValues('foo')).toBe('function');
    });
    it('should get the initial form values from state', function () {
      expect(getFormInitialValues('foo')(fromJS({
        form: {
          foo: {
            initial: {
              dog: 'Snoopy',
              cat: 'Garfield'
            }
          }
        }
      }))).toEqualMap({
        dog: 'Snoopy',
        cat: 'Garfield'
      });
    });
    it('should use getFormState if provided', function () {
      expect(getFormInitialValues('foo', function (state) {
        return getIn(state, 'someOtherSlice');
      })(fromJS({
        someOtherSlice: {
          foo: {
            initial: {
              dog: 'Snoopy',
              cat: 'Garfield'
            }
          }
        }
      }))).toEqualMap({
        dog: 'Snoopy',
        cat: 'Garfield'
      });
    });
  });
};

describeGetFormInitialValues('getFormInitialValues.plain', _plain.default, function () {
  return expect.extend(_expectations.default);
});
describeGetFormInitialValues('getFormInitialValues.immutable', _immutable.default, function () {
  return expect.extend(_expectations2.default);
});