"use strict";

var _getFormNames = _interopRequireDefault(require("../getFormNames"));

var _plain = _interopRequireDefault(require("../../structure/plain"));

var _expectations = _interopRequireDefault(require("../../structure/plain/__tests__/expectations"));

var _immutable = _interopRequireDefault(require("../../structure/immutable"));

var _expectations2 = _interopRequireDefault(require("../../structure/immutable/__tests__/expectations"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var describeGetFormNames = function describeGetFormNames(name, structure, setup) {
  var getFormNames = (0, _getFormNames.default)(structure);
  var fromJS = structure.fromJS,
      getIn = structure.getIn;
  describe(name, function () {
    beforeAll(function () {
      setup();
    });
    it('should return a function', function () {
      expect(typeof getFormNames()).toBe('function');
    });
    it('should get the form names from state', function () {
      expect(getFormNames()(fromJS({
        form: {
          foo: {
            values: {
              dog: 'Snoopy',
              cat: 'Garfield'
            }
          },
          bar: {
            values: {
              dog: 'Fido',
              cat: 'Whiskers'
            }
          }
        }
      }))).toEqualMap(['foo', 'bar']);
    });
    it('should use getFormState if provided', function () {
      expect(getFormNames(function (state) {
        return getIn(state, 'someOtherSlice');
      })(fromJS({
        someOtherSlice: {
          foo: {
            values: {
              dog: 'Snoopy',
              cat: 'Garfield'
            }
          },
          bar: {
            values: {
              dog: 'Fido',
              cat: 'Whiskers'
            }
          }
        }
      }))).toEqualMap(['foo', 'bar']);
    });
  });
};

describeGetFormNames('getFormNames.plain', _plain.default, function () {
  return expect.extend(_expectations.default);
});
describeGetFormNames('getFormNames.immutable', _immutable.default, function () {
  return expect.extend(_expectations2.default);
});