"use strict";

var _hasSubmitFailed = _interopRequireDefault(require("../hasSubmitFailed"));

var _plain = _interopRequireDefault(require("../../structure/plain"));

var _expectations = _interopRequireDefault(require("../../structure/plain/__tests__/expectations"));

var _immutable = _interopRequireDefault(require("../../structure/immutable"));

var _expectations2 = _interopRequireDefault(require("../../structure/immutable/__tests__/expectations"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var describeHasSubmitFailed = function describeHasSubmitFailed(name, structure, setup) {
  var hasSubmitFailed = (0, _hasSubmitFailed.default)(structure);
  var fromJS = structure.fromJS,
      getIn = structure.getIn;
  describe(name, function () {
    beforeAll(function () {
      setup();
    });
    it('should return a function XXX', function () {
      expect(typeof hasSubmitFailed('foo')).toBe('function');
    });
    it('should return false when value not present', function () {
      expect(hasSubmitFailed('foo')(fromJS({
        form: {}
      }))).toBe(false);
    });
    it('should return true when submitting', function () {
      expect(hasSubmitFailed('foo')(fromJS({
        form: {
          foo: {
            submitFailed: true
          }
        }
      }))).toBe(true);
    });
    it('should use getFormState if provided', function () {
      expect(hasSubmitFailed('foo', function (state) {
        return getIn(state, 'someOtherSlice');
      })(fromJS({
        someOtherSlice: {
          foo: {
            submitFailed: true
          }
        }
      }))).toBe(true);
    });
  });
};

describeHasSubmitFailed('hasSubmitFailed.plain', _plain.default, function () {
  return expect.extend(_expectations.default);
});
describeHasSubmitFailed('hasSubmitFailed.immutable', _immutable.default, function () {
  return expect.extend(_expectations2.default);
});