"use strict";

var _hasSubmitSucceeded = _interopRequireDefault(require("../hasSubmitSucceeded"));

var _plain = _interopRequireDefault(require("../../structure/plain"));

var _expectations = _interopRequireDefault(require("../../structure/plain/__tests__/expectations"));

var _immutable = _interopRequireDefault(require("../../structure/immutable"));

var _expectations2 = _interopRequireDefault(require("../../structure/immutable/__tests__/expectations"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var describeHasSubmitSucceeded = function describeHasSubmitSucceeded(name, structure, setup) {
  var hasSubmitSucceeded = (0, _hasSubmitSucceeded.default)(structure);
  var fromJS = structure.fromJS,
      getIn = structure.getIn;
  describe(name, function () {
    beforeAll(function () {
      setup();
    });
    it('should return a function XXX', function () {
      expect(typeof hasSubmitSucceeded('foo')).toBe('function');
    });
    it('should return false when value not present', function () {
      expect(hasSubmitSucceeded('foo')(fromJS({
        form: {}
      }))).toBe(false);
    });
    it('should return true when submitting', function () {
      expect(hasSubmitSucceeded('foo')(fromJS({
        form: {
          foo: {
            submitSucceeded: true
          }
        }
      }))).toBe(true);
    });
    it('should use getFormState if provided', function () {
      expect(hasSubmitSucceeded('foo', function (state) {
        return getIn(state, 'someOtherSlice');
      })(fromJS({
        someOtherSlice: {
          foo: {
            submitSucceeded: true
          }
        }
      }))).toBe(true);
    });
  });
};

describeHasSubmitSucceeded('hasSubmitSucceeded.plain', _plain.default, function () {
  return expect.extend(_expectations.default);
});
describeHasSubmitSucceeded('hasSubmitSucceeded.immutable', _immutable.default, function () {
  return expect.extend(_expectations2.default);
});