"use strict";

var _isAsyncValidating = _interopRequireDefault(require("../isAsyncValidating"));

var _plain = _interopRequireDefault(require("../../structure/plain"));

var _expectations = _interopRequireDefault(require("../../structure/plain/__tests__/expectations"));

var _immutable = _interopRequireDefault(require("../../structure/immutable"));

var _expectations2 = _interopRequireDefault(require("../../structure/immutable/__tests__/expectations"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var describeIsAsyncValidating = function describeIsAsyncValidating(name, structure, setup) {
  var isAsyncValidating = (0, _isAsyncValidating.default)(structure);
  var fromJS = structure.fromJS,
      getIn = structure.getIn;
  describe(name, function () {
    beforeAll(function () {
      setup();
    });
    it('should return a function XXX', function () {
      expect(typeof isAsyncValidating('foo')).toBe('function');
    });
    it('should return false when value not present', function () {
      expect(isAsyncValidating('foo')(fromJS({
        form: {}
      }))).toBe(false);
    });
    it('should return true when asynchronously validating', function () {
      expect(isAsyncValidating('foo')(fromJS({
        form: {
          foo: {
            asyncValidating: true
          }
        }
      }))).toBe(true);
    });
    it('should use getFormState if provided', function () {
      expect(isAsyncValidating('foo', function (state) {
        return getIn(state, 'someOtherSlice');
      })(fromJS({
        someOtherSlice: {
          foo: {
            asyncValidating: true
          }
        }
      }))).toBe(true);
    });
  });
};

describeIsAsyncValidating('isAsyncValidating.plain', _plain.default, function () {
  return expect.extend(_expectations.default);
});
describeIsAsyncValidating('isAsyncValidating.immutable', _immutable.default, function () {
  return expect.extend(_expectations2.default);
});