"use strict";

var _immutable = require("immutable");

var _keys = _interopRequireDefault(require("../keys"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var expectEqual = function expectEqual(a, b) {
  return expect((0, _immutable.is)(a, b)).toBe(true);
};

describe('structure.immutable.keys', function () {
  it('should return empty List if state is undefined', function () {
    expectEqual((0, _keys.default)(undefined), (0, _immutable.List)());
  });
  it('should return empty List if no keys', function () {
    expectEqual((0, _keys.default)((0, _immutable.Map)()), (0, _immutable.List)());
  });
  it('should return keys', function () {
    expectEqual((0, _keys.default)((0, _immutable.fromJS)({
      a: 1,
      b: 2,
      c: 3
    })), (0, _immutable.List)(['a', 'b', 'c']));
  });
  it('should return keys from plain object', function () {
    expectEqual((0, _keys.default)({
      a: 1,
      b: 2,
      c: 3
    }), (0, _immutable.List)(['a', 'b', 'c']));
  });
});