"use strict";

var _shallowCompare = _interopRequireDefault(require("../shallowCompare"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('shallowCompare', function () {
  it('should shallow compare props and state', function () {
    expect((0, _shallowCompare.default)({
      props: {
        a: 'a'
      },
      state: {
        b: 'b'
      }
    }, {
      a: 'a'
    }, {
      b: 'b'
    })).toBe(false);
  });
  it('should shallow compare props and state', function () {
    var aProp = new Date();
    var bState = [1, 2, 3];
    expect((0, _shallowCompare.default)({
      props: {
        a: aProp
      },
      state: {
        b: bState
      }
    }, {
      a: aProp
    }, {
      b: bState
    })).toBe(false);
  });
  it('should shallow compare props and state', function () {
    var aProp = new Date();
    var bState = [1, 2, 3];
    expect((0, _shallowCompare.default)({
      props: {
        a: aProp
      },
      state: {
        b: bState
      }
    }, {
      a: aProp
    }, {
      b: [1, 2, 3]
    })).toBe(true);
  });
});